<template>
  <div :class="['service', {'service--active': services, 'service--disabled': service.disabled}]" :style="`background-image: url(${bg})`">
    <div class="service__name">
      {{ service.title }}
      <div class="service__desc">
        {{ service.description }}
      </div>
    </div>
    <div class="service__action">
      <span v-if="service.price">{{ new Intl.NumberFormat("ru-RU").format(Math.round(service.price / 100)) }} ₽/{{service.unit}}</span>
      <ob-toggle v-model="services" @change="onInput" />
    </div>
  </div>
</template>

<script>
import ObToggle from "common-components/src/obComponents/obSwitcherCheckbox"
  export default {
    name: "serviceCard",

    props: {
      service: {
        type: Object,
        required: true
      },

      active: {
        type: Boolean,
        default: false
      }
    },

    components: {
      ObToggle
    },

    computed: {
      bg() {
        return this.services ? require(`src/assets/images/${this.service.icon}-active.svg`) : require(`src/assets/images/${this.service.icon}.svg`);
      }
    },

    watch: {
      active: {
        handler(newVal) {
          if (newVal) this.services = true;
        },
        immediate: true
      }
    },

    data() {
      return {
        services: false
      }
    },

    methods: {
      onInput($event) {
        this.$emit('serviceChanged', {status: $event, event: this.service});
      }
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.service {
  background-color: $background-color-light;
  background-repeat: no-repeat;
  background-position: top left;
  border: 1px solid $color-white-lilac;
  border-radius: 4px;
  display: flex;
  flex-direction: column;
  @include font-mixin(18px, 22px, 700, $color-grey-span);
  text-align: center;
  transition: all 0.3s ease-in-out;

  &--active {
    background-color: $blue-700;
    color: $lavender;

    .service__desc {
      background-color: $blue-700;
      color: $lavender;
    }

    .service__action {
      border-top: 1px solid rgba($blue-blue-hoarfrost, 0.3);
    }

    &::v-deep {  
      .ob-switcher-checkbox-container input:checked + .switch-box .switch-button {
        background: #fff;
        box-shadow: 2px 1px 4px rgba(0, 150, 222, 0.3), -1px 0px 3px rgba(51, 111, 211, 0.55);
      }

      .ob-switcher-checkbox-container input:checked + .switch-box {
        background: $blue-blue-hoarfrost;
      }
    }
  }

  &--disabled {

    .service__action {
      pointer-events: none;
    }

    &::v-deep {
      .ob-switcher-checkbox-container .switch-box {
        background: $gray-200;
      }

      .ob-switcher-checkbox-container input:checked + .switch-box {
        background: #336FD3;
      }
    }
  }

  .ob-switcher-checkbox-container:only-child {
    margin-left: auto;
  }
}

.service__name {
  position: relative;
  padding: 0 10px;
  flex: 0 0 122px;
  display: flex;
  justify-content: center;
  align-items: center;
  overflow: hidden;

  &:hover .service__desc {
    top: 0;
  }
}

.service__desc {
  position: absolute;
  width: 100%;
  height: 100%;
  padding: 10px;
  left: 0;
  top: -100%;
  font-size: 13px;
  line-height: 16px;
  font-weight: 400;
  text-align: left;
  background-color: $background-color-light;
}

.service__action {
  min-height: 40px;
  display: flex;
  align-items: center;
  justify-content: space-between;
  padding: 0 4px 0 11px;
  border-top: 1px solid rgba($color-grey-span, 0.1);
  font-size: 14px;
}
</style>